unit hiDatePicker;

interface

uses Kol,Share,Win,Calendar;

type
 THIDatePicker = class(THIWin)
   private
     DatePicker:PPicker;
     procedure _OnChange(Sender:PObj);
      public
      _event_OnChange:THI_Event;

      _prop_BackgroundColor:TColor;
      _prop_TitleBkColor:TColor;
      _prop_TitleTextColor:TColor;
      _prop_MonthBkColor:TColor;
      _prop_TrailingColor:TColor;


       _prop_DateFormat:integer;
       _prop_DateMode:integer;
       _prop_CheckBox:boolean;
       _prop_Time:boolean;
       _prop_Visible:boolean;
       _prop_Enabled:boolean;

     procedure Init; override;
     destructor Destroy; override;
     procedure _work_doSetDate(var _Data:TData; Index:word);
     procedure _work_doChecked(var _Data:TData; Index:word);
     procedure _var_Date(var _Data:TData; Index:word);
     procedure _var_Time(var _Data:TData; Index:word);
     procedure _var_Checked(var _Data:TData; Index:word);
end;

implementation

procedure THIDatePicker.Init;
var opt:TPickerOptions;
begin
opt:=[];
// 
if _prop_DateFormat=0 then
include(opt,piShortDate)
else
include(opt,piLongDate);
if _prop_DateMode=1 then
include(opt,piUpDown);
if _prop_Time then
include(opt,piTime);
if _prop_CheckBox then
include(opt,piCheckBox);
// 
DatePicker:=NewDatePicker(FParent,opt);
Control:=DatePicker.Control;
DatePicker.OnChange:=_OnChange;
DatePicker.SetAlign(_prop_Align);
DatePicker.SetPosition(_prop_Left,_prop_Top);
DatePicker.SetSize(_prop_Width,_prop_Height);
DatePicker.TabOrder:=_prop_TabOrder;
DatePicker.Enabled:=_prop_Enabled;
DatePicker.Visible:=_prop_Visible;
DatePicker.Color[clBackground]:= _prop_Color;
DatePicker.Color[clTitleBk]:= _prop_TitleBkColor;
DatePicker.Color[clTitleText]:= _prop_TitleTextColor;
DatePicker.Color[clMonthBk]:= _prop_MonthBkColor;
DatePicker.Color[clTrailing]:= _prop_TrailingColor;
DatePicker.Cursor:=_prop_Cursor;
end;

destructor THIDatePicker.Destroy;
begin
//   free_and_nil(DatePicker);
   inherited Destroy;
end;

procedure THIDatePicker._OnChange;
begin
   _hi_OnEvent(_event_OnChange);
end;

procedure THIDatePicker._work_doChecked;
begin
DatePicker.Checked:=ReadBool(_Data);
end;

procedure THIDatePicker._var_Date;
var s:string;
begin
    s:=DateTime2StrShort(DatePicker.DateTime);
   _Data.Data_type := data_str;
   _Data.sdata := GetTok(s,' ');
end;

procedure THIDatePicker._var_Time;
var s:string;
begin
    s:=DateTime2StrShort(DatePicker.DateTime);
    GetTok(s,' ');
   _Data.Data_type := data_str;
   _Data.sdata :=s;
end;

procedure THIDatePicker._var_Checked;
begin
   _Data.Data_type := data_int;
   _Data.idata :=Integer(DatePicker.Checked);
end;

procedure THIDatePicker._work_doSetDate;
begin
  DatePicker.DateTime:= Str2DateTimeShort(ToString(_Data));
end;
end.

